#!/usr/bin/perl -w

# perl seqRet.pl blastRes.txt chickenDB.fas

use strict;
use warnings;

my $blastRes = "$ARGV[0]";
my $dbFile = "$ARGV[1]";
#my $outFile = "Out_GeneGroup.fas";


### blast の結果を開けて，ID を拾ってくる
my @ids = ( );    # id を格納する

open(BLRES,"$blastRes");
my @blastFile = <BLRES>;
close BLRES;

foreach (@blastFile) {
  if($_ =~ /^>/){
    my $ensp = $_;
    chomp($ensp);
    $ensp =~ s/>//g;
    $ensp =~ s/ +.*?$//g;
#    print "$ensp\n";
    push(@ids,$ensp);
  }
}

### 配列をとってくるプログラム ####


# データベースファイルをあける．
open(INFILE,"$dbFile") or die "$!";
my @inFileCont = <INFILE>;
close INFILE;

my ($ref_fasHash,$ref_nameArray, $seqLength) = &fasHashReader(\@inFileCont);

# ファイルのプリントアウト
#open(OUT,">>$outFile");
foreach my $id (@ids) {
my @items = grep(/>$id/,@$ref_nameArray);
foreach (@items) {
  my $nameLine = $_;
  $nameLine =~ /^(>\w+) .*?$/;
  my $id2 = $1;
#  print OUT "$id2\n$$ref_fasHash{$nameLine}\n";
  print "$nameLine\n$$ref_fasHash{$nameLine}\n";
}
}
#close OUT;

exit;

#### サブルーチン ####

#  Fasta 形式をハッシュに読み込む Subroutine
sub fasHashReader
{
  my $name = "";
  my $seq = "";
  my $seqLength = "";
  my $stone = 0;
  my @nameArraySR = ( );
  my %fasHashSR = ( );

  my ($dbFileContSR) = @_;

  foreach my $dbFileLine (@$dbFileContSR) {
    chomp($dbFileLine);
    if($dbFileLine =~ /^>/){  
      if($stone == 0){$name = $dbFileLine;
        $stone = 1;  
      } else {
        $fasHashSR{$name} = $seq;  
        push(@nameArraySR,$name);
        $name = "$dbFileLine";
        $seq = "";
      }
    } else {
      $seq .= $dbFileLine; 
    }
  }
  $fasHashSR{$name} = $seq;
  $seqLength = length($seq);
  push(@nameArraySR,$name);

  # ハッシュと配列をメインプログラムに返す．
  return (\%fasHashSR,\@nameArraySR,\$seqLength);

}
